﻿<template>
    <v-app>
        <v-container>
            <v-tabs v-model="tab" show-arrows background-color="deep-purple accent-4" icons-and-text dark grow>
                <v-tabs-slider color="purple darken-4"></v-tabs-slider>
                <v-tab v-for="(item, index) in tabs" :key="index">
                    <v-icon large>{{ item.icon }}</v-icon>
                    <div class="caption py-1">{{ item.name }}</div>
                </v-tab>
                <v-tab-item>
                    <v-card class="px-4">
                        <v-card-text>
                            <v-form ref="form"
                                    v-model="valid"
                                    lazy-validation>
                                <v-row>
                                    <v-col cols="12">
                                        <v-text-field v-model="userName"
                                                      :rules="userNameRules"
                                                      label="Username"
                                                      required></v-text-field>
                                    </v-col>
                                    <v-col cols="12">
                                        <v-text-field v-model="password"
                                                      :rules="passwordRules"
                                                      label="Password"
                                                      type="password"
                                                      required></v-text-field>
                                    </v-col>
                                    <v-spacer></v-spacer>
                                    <v-col class="d-flex" cols="12" sm="3" xsm="12" align-end>
                                        <v-btn :disabled="!valid"
                                               color="success"
                                               class="mr-4"
                                               @click="onLogin">
                                            Submit
                                        </v-btn>
                                    </v-col>
                                </v-row>
                            </v-form>
                        </v-card-text>
                    </v-card>
                </v-tab-item>
                <v-tab-item>
                    <v-card class="px-4">
                        <v-card-text>
                            <v-form ref="formReg"
                                    v-model="validReg"
                                    lazy-validation>
                                <v-row>
                                    <v-col cols="12">
                                        <v-text-field v-model="email"
                                                      :rules="emailRules"
                                                      label="Email"
                                                      required></v-text-field>
                                    </v-col>
                                    <v-col cols="12">
                                        <v-text-field v-model="userNameReg"
                                                      :rules="userNameRules"
                                                      label="Username"
                                                      required></v-text-field>
                                    </v-col>
                                    <v-col cols="12">
                                        <v-text-field v-model="passwordReg"
                                                      :rules="passwordRules"
                                                      label="Password"
                                                      type="password"
                                                      counter
                                                      required></v-text-field>
                                    </v-col>
                                    <v-col cols="12">
                                        <v-text-field v-model="confirmPassword"
                                                      :rules="confirmPasswordRules"
                                                      label="Confirm password"
                                                      type="password"
                                                      counter
                                                      required></v-text-field>
                                    </v-col>
                                    <v-spacer></v-spacer>
                                    <v-col class="d-flex" cols="12" sm="3" xsm="12" align-end>
                                        <v-btn :disabled="!validReg"
                                               color="success"
                                               class="mr-4"
                                               @click="onRegister">
                                            Submit
                                        </v-btn>
                                    </v-col>
                                </v-row>
                            </v-form>
                        </v-card-text>
                    </v-card>
                </v-tab-item>
            </v-tabs>
        </v-container>
    </v-app>
</template>

<script>
    //import { mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                validReg: true,
                email: '',
                emailRules: [
                    v => !!v || 'Требуется электронная почта',
                    v => /.+@.+\..+/.test(v) || 'E-mail должен быть действительным'
                ],
                userName: '',
                userNameReg: '',
                userNameRules: [
                    v => !!v || 'Username is required',
                ],
                password: '',
                passwordReg: '',
                confirmPassword: '',
                passwordRules: [
                    v => !!v || 'Password is required'
                ],
                confirmPasswordRules: [
                    (value) => !!value || 'Confirm password field is required',
                    (value) =>
                        value === this.passwordReg || 'The password confirmation does not match.',
                ],
                checkbox: false,
                tab: 0,
                tabs: [
                    { name: "Login", icon: "mdi-account" },
                    { name: "Register", icon: "mdi-account-outline" }
                ],
                //valid: false,
                //checkbox: false,
                //login: true,
                //changePass: false,
                //email: '',
                //password: '',
                //emailRules: [
                //    v => !!v || 'Требуется электронная почта',
                //    v => /.+@.+\..+/.test(v) || 'E-mail должен быть действительным'
                //],
                //passwordRules: [v => !!v || 'Необходим пароль']
            }
        },
        
        methods: {
            validate() {
                this.$refs.form.validate()
            },
            validateReg() {
                this.$refs.formReg.validate()
            },
            async onLogin() {
                await this.validate()
                if (this.valid) {
                    let username = this.userName
                    let password = this.password
                    this.$store
                        .dispatch('auth/login',
                            {
                                username,
                                password
                            }
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch(err => {
                            if (err) {
                                this.userName = '';
                                this.password = '';
                                this.userNameRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                                this.passwordRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                            }
                        })
                } else return
            },
            async onRegister() {
                await this.validateReg()
                if (this.validReg) {
                    let email = this.email;
                    let username = this.userNameReg
                    let password = this.passwordReg
                    this.$store
                        .dispatch('auth/register',
                            {
                                email,
                                username,
                                password
                            }
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch(err => {
                            if (err) {
                                this.userName = '';
                                this.password = '';
                                this.userNameRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                                this.passwordRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                            }
                        })
                } else return
            }
        }
    }
</script>